{
   ,  Native API  (  ),     Native API 

                               14.12.2006
      :        (rpy3uH)
     E-mail:   ahilles1806@rambler.ru

}

unit ExtendedAPIFunctions;

interface

uses Windows;

const
     // SYSTEM_INFORMATION_CLASS
  SystemBasicInformation	        =       0;
  SystemProcessorInformation	        =	1;
  SystemPerformanceInformation         	=	2;
  SystemTimeOfDayInformation           	=	3;
  SystemNotImplemented1               	=	4;
  SystemProcessesAndThreadsInformation	=	5;
  SystemCallCounts	                =	6;
  SystemConfigurationInformation	=	7;
  SystemProcessorTimes                	=	8;
  SystemGlobalFlag                    	=	9;
  SystemNotImplemented2               	=	10;
  SystemModuleInformation             	=	11;
  SystemLockInformation	                =	12;
  SystemNotImplemented3	                =	13;
  SystemNotImplemented4                	=	14;
  SystemNotImplemented5	                =	15;
  SystemHandleInformation              	=	16;
  SystemObjectInformation	        =	17;
  SystemPagefileInformation            	=	18;
  SystemInstructionEmulationCounts	=	19;
  SystemInvalidInfoClass                =	20;
  SystemCacheInformation	        =	21;
  SystemPoolTagInformation            	=	22;
  SystemProcessorStatistics	        =	23;
  SystemDpcInformation                	=	24;
  SystemNotImplemented6	                =	25;
  SystemLoadImage	                =	26;
  SystemUnloadImage	                =	27;
  SystemTimeAdjustment                  =	28;
  SystemNotImplemented7               	=	29;
  SystemNotImplemented8	                =	30;
  SystemNotImplemented9               	=	31;
  SystemCrashDumpInformation          	=	32;
  SystemExceptionInformation          	=	33;
  SystemCrashDumpStateInformation      	=	34;
  SystemKernelDebuggerInformation     	=	35;
  SystemContextSwitchInformation	=	36;
  SystemRegistryQuotaInformation	=	37;
  SystemLoadAndCallImage               	=	38;
  SystemPrioritySeparation             	=	39;
  SystemNotImplemented10              	=	40;
  SystemNotImplemented11              	=	41;
  SystemInvalidInfoClass2              	=	42;
  SystemInvalidInfoClass3             	=	43;
  SystemTimeZoneInformation            	=	44;
  SystemLookasideInformation          	=	45;
  SystemSetTimeSlipEvent              	=	46;
  SystemCreateSession                 	=	47;
  SystemDeleteSession                  	=	48;
  SystemInvalidInfoClass4               =	49;
  SystemRangeStartInformation         	=	50;
  SystemVerifierInformation           	=       51;
  SystemAddVerifier                    	=       52;
  SystemSessionProcessesInformation   	=       53;


  STATUS_SUCCESS                        =       $00000000;
  STATUS_ACCESS_DENIED                  =       $C0000022;
  STATUS_INFO_LENGTH_MISMATCH           =       $C0000004;
  SEVERITY_ERROR                        =       $C0000000;

type
  NTStatus = Cardinal;

  PUNICODE_STRING = ^UNICODE_STRING;
  UNICODE_STRING = packed record
    Length: Word;
    MaximumLength: Word;
    Buffer: PWideChar;
   end;
   
  PVM_COUNTERS = ^VM_COUNTERS;
  VM_COUNTERS = packed record
    PeakVirtualSize,
    VirtualSize,
    PageFaultCount,
    PeakWorkingSetSize,
    WorkingSetSize,
    QuotaPeakPagedPoolUsage,
    QuotaPagedPoolUsage,
    QuotaPeakNonPagedPoolUsage,
    QuotaNonPagedPoolUsage,
    PagefileUsage,
    PeakPagefileUsage: DWORD;
   end;

  PIO_COUNTERS = ^IO_COUNTERS;
  IO_COUNTERS = packed record
    ReadOperationCount,
    WriteOperationCount,
    OtherOperationCount,
    ReadTransferCount,
    WriteTransferCount,
    OtherTransferCount: LARGE_INTEGER;
   end;

  PClientID = ^TClientID;
  TClientID = packed record
    UniqueProcess:DWORD;
    UniqueThread:DWORD;
   end;   

  PSYSTEM_THREADS = ^SYSTEM_THREADS;
  SYSTEM_THREADS = packed record
    KernelTime: LARGE_INTEGER;
    UserTime: LARGE_INTEGER;
    CreateTime: LARGE_INTEGER;
    WaitTime: DWORD;
    StartAddress: Pointer;
    ClientId: TClientID;
    Priority: DWORD;
    BasePriority: DWORD;
    ContextSwitchCount: DWORD;
    State: dword;
    WaitReason: dword;
   end;

  PSYSTEM_PROCESSES = ^_SYSTEM_PROCESSES;
  _SYSTEM_PROCESSES = packed record
    NextEntryDelta,
    ThreadCount: DWORD;
    Reserved1:array [0..5] of DWORD;
    CreateTime:LARGE_INTEGER;
    UserTime:LARGE_INTEGER;
    KernelTime:LARGE_INTEGER;
    ProcessName:UNICODE_STRING;
    BasePriority:DWORD;
    ProcessID:DWORD;
    InheritedFromProcessID:DWORD;
    HandleCount: DWORD;
    Reserved2: array [0..1] of DWORD;
    VmCounters: VM_COUNTERS;
    IoCounters: IO_COUNTERS; // Windows 2000 only
    Threads: array [0..0] of SYSTEM_THREADS;
   end;

 //--------------------External Functions-----------------------------------------
Function ZwQuerySystemInformation(ASystemInformationClass: DWORD; ASystemInformation: Pointer;
   ASystemInformationLength: DWORD; AReturnLength:PCardinal): NTStatus; stdcall;external 'ntdll.dll';
 //-------------------------------------------------------------------------------

Function GetSystemInfo(InfoClass:DWORD):Pointer;

implementation
                 //    
Function GetSystemInfo(InfoClass:DWORD):Pointer;
var
 mSize: DWORD;
 pInfoDATA: Pointer;
 NTRes: NTStatus;
begin
 Result := 0;
 mSize := $2000;
 repeat
  pInfoDATA := VirtualAlloc(0, mSize, MEM_COMMIT or MEM_RESERVE, PAGE_READWRITE);
  if pInfoDATA = nil then Exit;
  NTRes := ZwQuerySystemInformation(InfoClass, pInfoDATA, mSize, 0);
  if NTRes = STATUS_INFO_LENGTH_MISMATCH then
   begin
    VirtualFree(pInfoDATA, 0, MEM_RELEASE);
    mSize := mSize + $1000;
   end;
 until NTRes <> STATUS_INFO_LENGTH_MISMATCH;
 if NTRes = STATUS_SUCCESS  then Result := pInfoDATA
                            else VirtualFree(pInfoDATA, 0, MEM_RELEASE);
end;



end.
